'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var defaultFolder = exports.defaultFolder = 'api-name';
var defaultFile = exports.defaultFile = 'api-name.api.txt';
var defaultEndpointFile = exports.defaultEndpointFile = 'endpoint-name.txt';
var defaultEndpointSpec = exports.defaultEndpointSpec = 'endpoint-name.spec.txt';
var defaultEndpointValidation = exports.defaultEndpointValidation = 'endpoint-name.validation.txt';

var paths = exports.paths = {
  in: {
    api: {
      source: function source() {
        return process.cwd() + '/node_modules/api-endpoint-cli/dist/structure/api';
      },
      root: function root() {
        return this.source() + '/api-name';
      },
      file: function file() {
        return this.root() + '/api-name.api.txt';
      }
    },
    endpoint: {
      source: function source() {
        return process.cwd() + '/node_modules/api-endpoint-cli/dist/structure/endpoint';
      },
      file: function file() {
        return this.source() + '/' + defaultEndpointFile;
      },
      spec: function spec() {
        return this.source() + '/' + defaultEndpointSpec;
      },
      validation: function validation() {
        return this.source() + '/' + defaultEndpointValidation;
      }
    }
  },
  out: {
    api: {
      source: function source() {
        return process.cwd() + '/src/components/endpoint';
      },
      root: function root() {
        var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultFolder;

        return this.source() + '/' + name;
      },
      file: function file() {
        var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultFile;
        var folder = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultFolder;

        return this.root(folder) + '/' + name;
      }
    },
    endpoint: {
      source: function source(api) {
        return process.cwd() + '/src/components/endpoint/' + api;
      },
      rootEndpoint: function rootEndpoint(api) {
        return this.source(api) + '/endpoints';
      },
      rootValidation: function rootValidation(api) {
        return this.source(api) + '/validations';
      },
      fileEndpoint: function fileEndpoint(api, name) {
        return this.rootEndpoint(api) + '/' + name;
      },
      fileValidation: function fileValidation(api, name) {
        return this.rootValidation(api) + '/' + name;
      }
    }
  }
};