'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _config = require('../../config');

var _fs = require('fs');

var _fsExtra = require('fs-extra');

var _strings = require('../utils/strings');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(api, endpoint, path, verb) {
    var fileContentEndpoint, newFileContentEndpoint, fileContentApi, newFileContentApi, fileContentValidation, newFileContentValidation, fileContentSpec, newFileContentSpec;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return Promise.all([(0, _fsExtra.copy)(_config.paths.in.endpoint.file(), _config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointFile)), (0, _fsExtra.copy)(_config.paths.in.endpoint.spec(), _config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointSpec)), (0, _fsExtra.copy)(_config.paths.in.endpoint.validation(), _config.paths.out.endpoint.fileValidation(api, _config.defaultEndpointValidation))]).catch(function (err) {
              console.log('Err: ', err);process.exit(0);
            });

          case 2:

            //#####################################

            fileContentEndpoint = (0, _fs.readFileSync)(_config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointFile), 'utf-8');
            newFileContentEndpoint = fileContentEndpoint.replace(/_nameupper_/g, (0, _strings.splitHifenAndUpper)(endpoint)).replace(/_name_/g, endpoint).replace(/_verb_/g, verb).replace(/_path_/g, path);


            (0, _fs.writeFileSync)(_config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointFile), newFileContentEndpoint, 'utf-8');

            (0, _fs.renameSync)(_config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointFile), _config.paths.out.endpoint.fileEndpoint(api, endpoint + '.ts'));

            // ####################################

            fileContentApi = (0, _fs.readFileSync)(_config.paths.out.api.root(api + '/' + api + '.api.ts'), 'utf-8');
            newFileContentApi = fileContentApi.replace(/this.endpoints = \[/g, (0, _strings.pushEndpointToApi)(endpoint));


            (0, _fs.writeFileSync)(_config.paths.out.api.root(api + '/' + api + '.api.ts'), (0, _strings.appendImportEndpoint)(endpoint, newFileContentApi), 'utf-8');

            // ####################################

            fileContentValidation = (0, _fs.readFileSync)(_config.paths.out.endpoint.fileValidation(api, _config.defaultEndpointValidation), 'utf-8');
            newFileContentValidation = fileContentValidation.replace(/_nameupper_/g, (0, _strings.splitHifenAndUpper)(endpoint));


            (0, _fs.writeFileSync)(_config.paths.out.endpoint.fileValidation(api, _config.defaultEndpointValidation), newFileContentValidation, 'utf-8');

            (0, _fs.renameSync)(_config.paths.out.endpoint.fileValidation(api, _config.defaultEndpointValidation), _config.paths.out.endpoint.fileValidation(api, endpoint + '.validation.ts'));

            // ####################################

            fileContentSpec = (0, _fs.readFileSync)(_config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointSpec), 'utf-8');
            newFileContentSpec = fileContentSpec.replace(/_nameupper_/g, (0, _strings.splitHifenAndUpper)(endpoint)).replace(/_name_/g, endpoint).replace(/_apiupper_/g, (0, _strings.splitHifenAndUpper)(api) + 'Api').replace(/_api_/g, api).replace(/_nameupperfirstnot_/g, (0, _strings.splitHifenAndUpperFirstNot)(endpoint)).replace(/_apiupperfirstnot_/g, (0, _strings.splitHifenAndUpperFirstNot)(api) + 'Api');


            (0, _fs.writeFileSync)(_config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointSpec), newFileContentSpec, 'utf-8');

            (0, _fs.renameSync)(_config.paths.out.endpoint.fileEndpoint(api, _config.defaultEndpointSpec), _config.paths.out.endpoint.fileEndpoint(api, endpoint + '.spec.ts'));

            return _context.abrupt('return');

          case 18:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();